"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("dayjs/locale/tr");
var b_validate_1 = require("b-validate");
var Calendar = {
    formatYear: 'YYYY',
    formatMonth: 'MMM YYYY',
    monthBeforeYear: true,
    today: 'Bugün',
    view: {
        month: 'Ay',
        year: 'Yıl',
        week: 'Hafta',
        day: 'Gün',
    },
    month: {
        long: {
            January: 'Ocak',
            February: 'Şubat',
            March: 'Mart',
            April: 'Nisan',
            May: 'Mayıs',
            June: 'Haziran',
            July: 'Temmuz',
            August: 'Ağustos',
            September: 'Eylül',
            October: 'Ekim',
            November: 'Kasım',
            December: 'Aralık',
        },
        short: {
            January: 'Oca',
            February: 'Şub',
            March: 'Mar',
            April: 'Nis',
            May: 'May',
            June: 'Haz',
            July: 'Tem',
            August: 'Ağu',
            September: 'Eyl',
            October: 'Eki',
            November: 'Kas',
            December: 'Ara',
        },
    },
    week: {
        long: {
            self: 'Hafta',
            monday: 'Pazartesi',
            tuesday: 'Salı',
            wednesday: 'Çarşamba',
            thursday: 'Perşembe',
            friday: 'Cuma',
            saturday: 'Cumartesi',
            sunday: 'Pazar',
        },
        short: {
            self: 'Hafta',
            monday: 'Pzt',
            tuesday: 'Sal',
            wednesday: 'Çar',
            thursday: 'Per',
            friday: 'Cum',
            saturday: 'Cmt',
            sunday: 'Paz',
        },
    },
};
exports.default = {
    locale: 'tr-TR',
    dayjsLocale: 'tr',
    Calendar: Calendar,
    DatePicker: {
        Calendar: Calendar,
        placeholder: {
            date: 'Tarih seç',
            week: 'Hafta seç',
            month: 'Ay seç',
            year: 'Yıl seç',
            quarter: 'Çeyrek seç',
        },
        placeholders: {
            date: ['Başlangıç tarihi', 'Bitiş tarihi'],
            week: ['Başlangıç haftası', 'Bitiş haftası'],
            month: ['Başlangıç ayı', 'Bitiş ayı'],
            year: ['Başlangıç yılı', 'Bitiş yılı'],
            quarter: ['Başlangıç çeyrek', 'Bitiş çeyrek'],
        },
        selectTime: 'Zaman seç',
        selectDate: 'Tarih seç',
        today: 'Bugün',
        now: 'Şimdi',
        ok: 'Tamam',
    },
    Drawer: {
        okText: 'Tamam',
        cancelText: 'İptal',
    },
    Empty: {
        noData: 'Veri yok',
    },
    Modal: {
        okText: 'Tamam',
        cancelText: 'İptal',
    },
    Pagination: {
        goto: 'Git',
        page: 'Sayfa',
        countPerPage: ' / Sayfa',
        total: 'Toplam: {0}',
        prev: 'Önceki',
        next: 'Sonraki',
        currentPage: 'sayfa {0}',
        prevSomePages: 'Önceki {0} sayfa',
        nextSomePages: 'Sonraki {0} sayfa',
        pageSize: 'Sayfa boyutu',
    },
    Popconfirm: {
        okText: 'Tamam',
        cancelText: 'İptal',
    },
    Table: {
        okText: 'Tamam',
        resetText: 'Sıfırla',
        sortAscend: 'Artan sıralamak için tıklayın',
        sortDescend: 'Azalan sıralamak için tıklayın',
        cancelSort: 'Sıralamayı iptal etmek için tıklayın',
    },
    TimePicker: {
        ok: 'Tamam',
        placeholder: 'Zaman seç',
        placeholders: ['Başlangıç zamanı', 'Bitiş zamanı'],
        now: 'Şimdi',
    },
    Progress: {
        success: 'Tamamlandı',
        error: 'Hata',
    },
    Upload: {
        start: 'Başlat',
        cancel: 'İptal',
        delete: 'Sil',
        reupload: 'Tekrar yükle',
        upload: 'Yükle',
        preview: 'Önizleme',
        drag: 'Dosyaları buraya sürükleyin',
        dragHover: 'Yüklemek için bırakın',
        error: 'Yükleme hatası',
    },
    Typography: {
        copy: 'Kopyala',
        copied: 'Kopyalandı',
        edit: 'Düzenle',
        fold: 'Katla',
        unfold: 'Aç',
    },
    Transfer: {
        resetText: 'Sıfırla',
    },
    ImagePreview: {
        fullScreen: 'Tam ekran',
        rotateRight: 'Sağa Döndür',
        rotateLeft: 'Sola Döndür',
        zoomIn: 'Yakınlaştır',
        zoomOut: 'Uzaklaştır',
        originalSize: 'Orjinal Boyut',
    },
    Form: b_validate_1.DefaultValidateMessage,
};
